
#include <GDIPlus.au3>

Opt('GUIOnEventMode', 1)

Global Const $sTitle = 'GDI+Template'
Global Const $iW = 600
Global Const $iH = 400

Global $bExit = False

_GDIPlus_Startup()
Global $hGUI = GUICreate($sTitle, $iW, $iH)
Global $hGFX = _GDIPlus_GraphicsCreateFromHWND($hGUI)
Global $hBMP = _GDIPlus_BitmapCreateFromGraphics($iW, $iH, $hGFX)
Global $hBUF = _GDIPlus_ImageGetGraphicsContext($hBMP)
Global $hBRU = _GDIPlus_BrushCreateSolid(0xFF888888)
Global $hIMG1 = _GDIPlus_ImageLoadFromFile('Testbild1.png')
Global $hIMG2 = _GDIPlus_ImageLoadFromFile('Testbild2.png')

;~ _GDIPlus_BitmapSetResolution($hIMG1, 96, 96) ; Uncomment this line to solve the problem.

Global $Info1 = Info($hIMG1)
Global $Info2 = Info($hIMG2)

Func Info($i)
	Local $aSize = _GDIPlus_ImageGetDimension($i)
	Local $aFlags = _GDIPlus_ImageGetFlags($i)
	Local $Info[]
	$Info.SizeX = $aSize[0]
	$Info.SizeY = $aSize[1]
	$Info.Width = _GDIPlus_ImageGetWidth($i)
	$Info.Height = _GDIPlus_ImageGetHeight($i)
	$Info.iPixelFlag = $aFlags[0]
	$Info.sPixelFlag = $aFlags[1]
	$Info.iVerticalDPI = _GDIPlus_ImageGetVerticalResolution($i)
	$Info.iHorizontalDPI = _GDIPlus_ImageGetVerticalResolution($i)
	Return $Info
EndFunc

Func DrawInfo($hGFX, $i, $x, $y, $hBRU)
	Local $hFAM = _GDIPlus_FontFamilyCreate('Arial')
	Local $hFON = _GDIPlus_FontCreate($hFAM, 12, 0, 2)
	Local $hFOR = _GDIPlus_StringFormatCreate()
	Local $sInfo = 'Size = [' & $i.SizeX & ', ' & $i.SizeY & '] (from getDimension)' & @CRLF & _
	'Size = [' & $i.Width & ', ' & $i.Height & '] (from getWidth & getHeight)' & @CRLF & _
	'Flags = ' & $i.iPixelFlag & @CRLF & '(as String: ' & $i.sPixelFlag & ')' & @CRLF & _
	'DPI = [vert: ' & $i.iVerticalDPI & ', horz: ' & $i.iHorizontalDPI & ']'
	_GDIPlus_GraphicsDrawStringEx($hGFX, $sInfo, $hFON, _GDIPlus_RectFCreate($x, $y, 300, 300), $hFOR, $hBRU)
	_GDIPlus_StringFormatDispose($hFOR)
	_GDIPlus_FontDispose($hFON)
	_GDIPlus_FontFamilyDispose($hFAM)
EndFunc

GUISetOnEvent(-3, 'EVENT', $hGUI)
OnAutoItExitRegister('Xit')
GUISetState(@SW_SHOW, $hGUI)

While Not $bExit And Sleep(10)
	_GDIPlus_GraphicsClear($hBUF, 0xFF202020)
	_GDIPlus_GraphicsDrawImage($hBUF, $hIMG1, 0, 0)
;~ 	_GDIPlus_GraphicsDrawImageRect($hBUF, $hIMG1, 0, 0, _GDIPlus_ImageGetWidth($hIMG1), _GDIPlus_ImageGetHeight($hIMG1))
	DrawInfo($hBUF, $Info1, 0, 270, $hBRU)
	_GDIPlus_GraphicsDrawImage($hBUF, $hIMG2, 300, 0)
	DrawInfo($hBUF, $Info2, 300, 270, $hBRU)
	_GDIPlus_GraphicsDrawImageRect($hGFX, $hBMP, 0, 0, $iW, $iH)
WEnd

Func EVENT()
	Switch @GUI_CtrlId
		Case -3
			$bExit = True
	EndSwitch
EndFunc

Func Xit()
	_GDIPlus_BrushDispose($hBRU)
	_GDIPlus_ImageDispose($hIMG2)
	_GDIPlus_ImageDispose($hIMG1)
	_GDIPlus_GraphicsDispose($hBUF)
	_GDIPlus_BitmapDispose($hBMP)
	_GDIPlus_GraphicsDispose($hGFX)
	_GDIPlus_Shutdown()
EndFunc